<%@ Page Language="C#" %>
<%@ Import Namespace="System.Security.Cryptography" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<script runat="server" type="text/C#">
	/// <summary>Your Secure Key from the publishing pipeline.</summary>
	private static readonly string SECRET = "YOUR KEY GOES HERE";
	
	/// <summary>Webname of the calendar you are securing.</summary>
	private static readonly string WEBNAME = "YOUR WEBNAME GOES HERE";

	/// <summary># days that secure URL is good for - keep this small, say <= 7.</summary>
	private static readonly double LIFETIME = 1.0;
	
	/// <summary>
	/// Compute the MD5 hash of a string in a manner that is compatible with Trumba's secure Urls.
	/// </summary>
	/// <param name="data">String to hash.</param>
	/// <returns>Hex string containing MD5 hash of data.</returns>
	private static string ComputeHash(string data)
	{
		MD5 md5 = new MD5CryptoServiceProvider();
		byte[] hash = md5.ComputeHash(Encoding.ASCII.GetBytes(data));

		StringBuilder hashText = new StringBuilder();

		for (int i = 0; i < hash.Length; i++)
			hashText.Append(hash[i].ToString("x2"));

		return hashText.ToString();
	}

	/// <summary>
	/// Generates the secure hash parameter that is good for 24 hours.
	/// </summary>
	private static string CreateSecureHash()
	{
		string expires = DateTime.UtcNow.AddDays(LIFETIME).ToString("yyyyMMddHHmm");
		string minimal = String.Format("calendar={0}&expires={1}&hash={2}", WEBNAME, expires, SECRET);
		string hash = ComputeHash(minimal);
		return string.Format("hash: '{0}', expires: '{1}'", hash, expires);
	}
</script>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>Trumba Secure URL Example</title>
	<script src="//www.trumba.com/scripts/spuds.js" type="text/javascript"></script>
	<style type="text/css">
		.error { font-size:smaller; color: red; }
		.para { font-size:small; }
	</style>
</head>
<body style="font-family:Verdana, Arial;">
	<form id="form1" runat="server" style="width:700px;">
		<div>
			<h1>Trumba Secure URL Example</h1>
			
			<p class="para">
				This page is an example of how to securely embed calendar Spuds using Trumba Secure
				URLs. The code behind this page uses your secure key to create a hash parameter that
				is passed to the $Trumba.addSpud() function.  This value is generated every time the 
				page is accessed and is only good for a short amount of time that you control.</p>
			
			<p class="para">In order to use Secure URLs you must first publish a calendar
				and turn on the Secure URL security setting.  See the 
				<a href="http://www.trumba.com/help/tableofcontents.html">Trumba online help</a> 
				for more information.  Once you have published the calendar edit this file's 
				code behind to change the SECRET and WEBNAME constants to the Secure Key and 
				web name of your published calendar.  You should then see your calendar below.  If you see the error 
				<span class="error">Theres no public calendar named YOUR WEBNAME GOES HERE.</span>
				then you need to edit the code behind.  If you see the error
				<span class="error">This calendar requires Secure URLs.</span> then your code
				behind's SECRET value is incorrect.
			</p>
			
			<table style="width:675px; border-top:2px solid gray;">
				<tbody>
					<tr valign="top">
						<!-- Right Column : Calendar -->
						<td style="width:500px;">
							<script type="text/javascript">
								$Trumba.addSpud({
									webName: "<%=WEBNAME %>",
									spudType: "main",
									url: { <%= CreateSecureHash() %> }
								});
							</script>
						</td>
						<!-- Left Column : Date Picker & View Chooser -->
						<td style="width:175px;">
							<script type="text/javascript">
								$Trumba.addSpud({
									webName: "<%=WEBNAME %>",
									spudType: "datefinder",
									url: { <%= CreateSecureHash() %> }
								});
							</script>
							<br />
							<script type="text/javascript">
								$Trumba.addSpud({
									webName: "<%=WEBNAME %>",
									spudType: "chooser",
									url: { <%= CreateSecureHash() %> }
								});
							</script>
						</td>
					</tr>
				</tbody>
			</table>
		</div>
	</form>
</body>
</html>
